#ifndef POLYHEDRALCONE_H_INCLUDED
#define POLYHEDRALCONE_H_INCLUDED

#include "vektor.h"

/* This is not how the code works right now, but how it should work when it is complete.
A cone is represented by halfSpaces and linearitySpace. The idea is that linearitySpace is always updated by calling computeAndReduceLinearitySpace() when something is changed. If an element in halfSpaces is implied by linearitySpace it might be removed during this process. The set of halfspaces is not minimised until reduce() is called. The reason for this is that most functions do not require the heavy reduction computation.
 */
class PolyhedralCone
{
  int n;
  IntegerVectorList halfSpaces;
  IntegerVectorList linearitySpace;  // Is "linearity space" the right word?
  //  void computeAndReduceLinearitySpace();
  void reduce();
 public:
  PolyhedralCone(int ambientDimension);
  PolyhedralCone(IntegerVectorList const &halfSpaces_, IntegerVectorList const &linearitySpace_, int ambientDimension=-1);
  IntegerVector relativeInteriorPoint(bool strictlyPositive)const;
  int ambientDimension()const;
  int dimension()const;
  bool isZero()const;
  friend PolyhedralCone intersection(const PolyhedralCone &a, const PolyhedralCone &b);
  static PolyhedralCone positiveOrthant(int dimension); 
};

#endif
